import LogicFlow, { BaseNodeModel } from '@logicflow/core';
export type INodeSelectionProperties = {
    strokeColor?: string | 'none';
    node_selection_ids?: string[];
};
declare class NodeSelection {
    static pluginName: string;
    lf: LogicFlow;
    selectNodes: any[];
    currentClickNode: any;
    d: number;
    constructor({ lf }: LogicFlow.IExtensionProps);
    /**
     * 获取所选node的id数组
     */
    get selectNodesIds(): string[];
    /**
     * 新建node-selection节点
     */
    addNodeSelection(): void;
    /**
     * 更新node-selection节点
     */
    updateNodeSelection(): void;
    /**
     * 获取所属的node-selection
     */
    getNodeSelection(): LogicFlow.NodeData | undefined;
    protected onNodeChange(lf: LogicFlow, model: BaseNodeModel): void;
    render(lf: LogicFlow): void;
}
export default NodeSelection;
export { NodeSelection };
