import LogicFlow, { BaseEdgeModel, BaseNodeModel, GraphModel, h } from '@logicflow/core';
import LabelData = LogicFlow.LabelData;
import LabelConfig = LogicFlow.LabelConfig;
import GraphElement = LogicFlow.GraphElement;
export declare class LabelModel {
    id: string;
    type: string;
    x: number;
    y: number;
    content: string;
    value: string;
    rotate?: number;
    style: h.JSX.CSSProperties;
    zIndex?: number;
    vertical: boolean;
    editable: boolean;
    draggable: boolean;
    labelWidth?: number;
    textOverflowMode: 'ellipsis' | 'wrap' | 'clip' | 'nowrap' | 'default';
    element: BaseNodeModel | BaseEdgeModel;
    graphModel: GraphModel;
    constructor(config: LabelConfig, element: GraphElement, graphModel: GraphModel);
    initLabelData(config: LabelConfig): void;
    getData(): LabelData;
}
export default LabelModel;
