import LogicFlow, { Component, GraphModel, h } from '@logicflow/core';
import type { IToolProps } from '@logicflow/core';
import LabelModel from './LabelModel';
import { MediumEditor } from './mediumEditor';
import LabelConfig = LogicFlow.LabelConfig;
export type LabelConfigType = string | LabelConfig | LabelConfig[];
export interface ILabelOverlayState {
    tick: number;
}
export declare class LabelOverlay extends Component<IToolProps, ILabelOverlayState> {
    static toolName: string;
    lf: LogicFlow;
    editor?: MediumEditor;
    graphModel: GraphModel;
    labelMap: Map<string, LabelModel>;
    constructor(props: IToolProps);
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    /**
     * 获取当前画布上所有的 label
     * 1. 第一步，先把当前所有的 text 转换为 label 进行展示
     * 2. 数据同步，text 编辑后，同步更新 label，并重新渲染
     */
    getLabels(): h.JSX.Element[] | null;
    render(): h.JSX.Element;
}
export default LabelOverlay;
