import LogicFlow, { GraphModel, EllipseNode, EllipseNodeModel } from '@logicflow/core';
import { PCTResizeParams } from './RectResize';
import NodeConfig = LogicFlow.NodeConfig;
export type ResizeEllipseNodeConfig = NodeConfig & {
    properties: {
        nodeSize: {
            rx: number;
            ry: number;
        };
    } & Record<string, unknown>;
};
export declare class EllipseResizeModel extends EllipseNodeModel {
    PCTResizeInfo?: PCTResizeParams;
    minWidth: number;
    minHeight: number;
    maxWidth: number;
    maxHeight: number;
    constructor(data: ResizeEllipseNodeConfig, graphModel: GraphModel);
    initNodeData(data: any): void;
    getOutlineStyle(): LogicFlow.OutlineTheme;
    getResizeOutlineStyle(): {
        fill: string;
        stroke: string;
        strokeWidth: number;
        strokeDasharray: string;
    };
    getControlPointStyle(): {
        width: number;
        height: number;
        fill: string;
        stroke: string;
    };
    enableProportionResize(turnOn?: boolean): void;
}
export declare class EllipseResizeView extends EllipseNode {
    getControlGroup(): import("preact").JSX.Element;
    getResizeShape(): import("preact").JSX.Element;
    getShape(): import("preact").JSX.Element;
}
export declare const EllipseResize: {
    type: string;
    view: typeof EllipseResizeView;
    model: typeof EllipseResizeModel;
};
export default EllipseResize;
